<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInstitutionInstitution ArrayType
 * @subpackage Arrays
 */
class ArrayOfInstitutionInstitution extends AbstractStructArrayBase
{
    /**
     * The Institution
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Institution[]
     */
    public $Institution;
    /**
     * Constructor method for ArrayOfInstitutionInstitution
     * @uses ArrayOfInstitutionInstitution::setInstitution()
     * @param \StructType\Institution[] $institution
     */
    public function __construct(array $institution = array())
    {
        $this
            ->setInstitution($institution);
    }
    /**
     * Get Institution value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Institution[]|null
     */
    public function getInstitution()
    {
        return isset($this->Institution) ? $this->Institution : null;
    }
    /**
     * Set Institution value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Institution[] $institution
     * @return \ArrayType\ArrayOfInstitutionInstitution
     */
    public function setInstitution(array $institution = array())
    {
        foreach ($institution as $arrayOfInstitutionInstitutionInstitutionItem) {
            // validation for constraint: itemType
            if (!$arrayOfInstitutionInstitutionInstitutionItem instanceof \StructType\Institution) {
                throw new \InvalidArgumentException(sprintf('The Institution property can only contain items of \StructType\Institution, "%s" given', is_object($arrayOfInstitutionInstitutionInstitutionItem) ? get_class($arrayOfInstitutionInstitutionInstitutionItem) : gettype($arrayOfInstitutionInstitutionInstitutionItem)), __LINE__);
            }
        }
        if (is_null($institution) || (is_array($institution) && empty($institution))) {
            unset($this->Institution);
        } else {
            $this->Institution = $institution;
        }
        return $this;
    }
    /**
     * Add item to Institution value
     * @throws \InvalidArgumentException
     * @param \StructType\Institution $item
     * @return \ArrayType\ArrayOfInstitutionInstitution
     */
    public function addToInstitution(\StructType\Institution $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Institution) {
            throw new \InvalidArgumentException(sprintf('The Institution property can only contain items of \StructType\Institution, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Institution[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Institution|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Institution|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Institution|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Institution|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Institution|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Institution
     */
    public function getAttributeName()
    {
        return 'Institution';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfInstitutionInstitution
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
